<!doctype html>
<html>
<head>
    <!-- Internal game scripts/styles, mostly boring stuff -->
    <script src="https://xss-game.appspot.com/static/game-frame.js"></script>
    <link rel="stylesheet" href="https://xss-game.appspot.com/static/game-frame-styles.css"/>
</head>

<body id="level6">
<img src="https://xss-game.appspot.com/static/logos/level6.png">
<img id="cube" src="https://xss-game.appspot.com/static/level6_cube.png">
<div id="log">Loading gadget...</div>

<script>
  //PROTECTION
  let whiteList =
    ['static/gadget.js',
      'static/gadget2.js',
      'static/gadget3.js'];

  //PROTECTION

  function setInnerText(element, value) {
    if (element.innerText) {
      element.innerText = value;
    } else {
      element.textContent = value;
    }
  }

  //PROTECTION
  function includeGadget(url) {
    var scriptEl = document.createElement('script');
    if (!whiteList.find((item) => item === url)) {
      setInnerText(document.getElementById('log'),
        'Sorry, this url is not allowed');
      return;
    }
    //PROTECTION

    scriptEl.src = url;

    scriptEl.onload = function () {
      setInnerText(document.getElementById('log'),
        'Loaded gadget from ' + url);
    };
    scriptEl.onerror = function () {
      setInnerText(document.getElementById('log'),
        'Couldn\'t load gadget from ' + url);
    };

    document.head.appendChild(scriptEl);
  }

  function getGadgetName() {
    return window.location.hash.substr(1) || 'static/gadget.js';
  }

  includeGadget(getGadgetName());

  window.addEventListener('message', function (event) {
    if (event.source == parent) {
      includeGadget(getGadgetName());
    }
  }, false);

</script>
</body>
</html>
